package src.data.scripts.weapons;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.BeamAPI;
import com.fs.starfarer.api.combat.BeamEffectPlugin;
import com.fs.starfarer.api.combat.CollisionClass;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.FluxTrackerAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.util.IntervalUtil;
import java.awt.Color;
import org.lazywizard.lazylib.VectorUtils;
import org.lwjgl.util.vector.Vector2f;

public class Art_Overridebeameffect implements BeamEffectPlugin {

    private static final Color COLOR = new Color(255, 25, 25, 255);
    private static final float MUZZLE_OFFSET_HARDPOINT = 4.0f;
    private static final float MUZZLE_OFFSET_TURRET = 7.0f;
    private static final Vector2f ZERO = new Vector2f();
    private final IntervalUtil interval = new IntervalUtil(0.1f, 0.1f);

    @Override
    public void advance(float amount, CombatEngineAPI engine, BeamAPI beam) {
        if (Global.getCombatEngine().isPaused()) {
            return;
        }

        Vector2f origin = new Vector2f(beam.getWeapon().getLocation());
        Vector2f offset = beam.getWeapon().getSlot().isHardpoint() ? new Vector2f(MUZZLE_OFFSET_HARDPOINT, 0f) : new Vector2f(MUZZLE_OFFSET_TURRET, 0f);
        VectorUtils.rotate(offset, beam.getWeapon().getCurrAngle(), offset);
        Vector2f.add(offset, origin, origin);
        interval.advance(amount);
        float level = beam.getBrightness();
        ShipAPI shipdamaged = null;
        Global.getCombatEngine().addHitParticle(origin, ZERO, level * 100f, 0.2f, 0.1f, COLOR);
        if (interval.intervalElapsed()) {
            if (beam.getDamageTarget() != null) {
                if (!beam.getDamageTarget().getCollisionClass().equals(CollisionClass.ASTEROID)) {
                    if (beam.getDamageTarget() instanceof ShipAPI) {
                        shipdamaged = (ShipAPI) beam.getDamageTarget();
                        float damage = beam.getWeapon().getDamage().getDamage();
                        FluxTrackerAPI FLUXTARGET = shipdamaged.getFluxTracker();
                        if (FLUXTARGET.isOverloadedOrVenting()) {
                            if (FLUXTARGET.getMaxFlux() > FLUXTARGET.getCurrFlux()) {
                                FLUXTARGET.setCurrFlux(FLUXTARGET.getCurrFlux() + damage * 3);
                            }
                        } else {
                            FLUXTARGET.increaseFlux(damage * 8, true);
                        }
                    }
                }
            }
        }

    }
}
