package src.lt.data.scripts.world.systems;

import com.fs.starfarer.api.Global;

import com.fs.starfarer.api.campaign.PlanetAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;

import com.fs.starfarer.api.campaign.StarSystemAPI;

import java.awt.Color;

public class ShilGen {

    //@Override
    public void generate(SectorAPI sector) {
        StarSystemAPI system = sector.getStarSystem("Askonia");

        PlanetAPI star = system.getStar();

        PlanetAPI a1 = system.addPlanet("bin", star, "Bin", "arid", 0, 60, 3500, 200);
        a1.getSpec().setGlowTexture(Global.getSettings().getSpriteName("hab_glows", "asharu"));
        a1.getSpec().setGlowColor(new Color(255, 255, 255, 255));
        a1.getSpec().setUseReverseLightForGlow(true);
        a1.applySpecChanges();
        a1.setInteractionImage("illustrations", "Lte_arid");

 /*
         * addPlanet() parameters:
         * 1. What the planet orbits (orbit is always circular)
         * 2. Name
         * 3. Planet type id in planets.json
         * 4. Starting angle in orbit, i.e. 0 = to the right of the star
         * 5. Planet radius, pixels at default zoom
         * 6. Orbit radius, pixels at default zoom
         * 7. Days it takes to complete an orbit. 1 day = 10 seconds.
         */
        SectorEntityToken station = system.addCustomEntity("Bin_station","Long-X5195", "station_side02", "Lte");
        station.setCircularOrbitPointingDown(system.getEntityById("bin"), 25, 500, 50);
        station.setInteractionImage("illustrations", "orbital");

        system = sector.getStarSystem("Tyle");

        SectorEntityToken starsecond= system.getEntityById("antillia");

        
        PlanetAPI sing3_1 = system.addPlanet("blow", starsecond, "Blow", "water", 100, 70, 1500, 300);
        PlanetAPI sing3_3 = system.addPlanet("monus", sing3_1, "Monus", "cryovolcanic", 30, 40,600, 100);
        sing3_3.setInteractionImage("illustrations", "Lte_ice_colony");
        SectorEntityToken sing_station1 = system.addCustomEntity("Blow_station", "Long-X5196", "station_side02", "Lte");
        sing_station1.setCircularOrbitPointingDown(system.getEntityById("blow"), 45, 300, 50);

        
    }
}
